<template>
  <q-page class="q-pa-sm">
    <div class="row q-col-gutter-sm q-py-sm" style="width: 100%">
      <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
        <q-card class="text-grey-8" style="width: 100%">
          <q-card-section class="q-pa-none">
            <q-table class="no-shadow"
                     :data="data"
                     title="Laporan Kehadiran Dosen"
                     :hide-header="mode === 'grid'"
                     :columns="columns"
                     row-key="name"
                     :filter="filter"
                     :pagination.sync="pagination"
                     hide-bottom
            >
              <template v-slot:top-right="props">
                <q-input borderless dense debounce="300" v-model="filter" placeholder="Cari">
                  <template v-slot:append>
                    <q-icon name="search"/>
                  </template>
                </q-input>
                

                <q-btn
                  color="primary"
                  label="Export"
                  no-caps
                  @click="exportTable"
                />
              </template>
              <template v-slot:body-cell-Action="props">
                <q-td :props="props">
                  <q-btn icon="edit" size="sm" flat dense/>
                  <q-btn icon="delete" size="sm" class="q-ml-sm" flat dense/>
                </q-td>
              </template>
            </q-table>
          </q-card-section>
        </q-card>
      </div>
    </div>
  </q-page>
</template>

<script>
  import {exportFile} from 'quasar'
  function wrapCsvValue(val, formatFn) {
        let formatted = formatFn !== void 0
            ? formatFn(val)
            : val

        formatted = formatted === void 0 || formatted === null
            ? ''
            : String(formatted)

        formatted = formatted.split('"').join('""')
        /**
         * Excel accepts \n and \r in strings, but some other CSV parsers do not
         * Uncomment the next two lines to escape new lines
         */
        // .split('\n').join('\\n')
        // .split('\r').join('\\r')

        return `"${formatted}"`
    }

  export default {
    name: 'Laporan_BAAK',
    data() {
      return {
                filter: '',
                mode: 'list',
                columns: [
                    {
                      name: 'tanggal', 
                      align: 'left', 
                      label: 'Tanggal', 
                      field: 'tanggal', 
                      sortable: true
                    },
                    {
                      name: 'nama_dosen', 
                      align: 'left', 
                      label: 'Nama Dosen', 
                      field: 'nama_dosen', 
                      sortable: true
                    },
                    {
                        name: 'matakuliah',
                        align: 'left',
                        label: 'Matakuliah',
                        field: 'matakuliah',
                        sortable: true
                    },
                    {
                        name: 'kelas',
                        align: 'left',
                        label: 'Kelas',
                        field: 'kelas',
                        sortable: true
                    },
                    {
                        name: 'ruangan',
                        align: 'left',
                        label: 'Ruangan',
                        field: 'ruangan',
                        sortable: true
                    },
                    {
                        name: 'jam_hadir',
                        align: 'left',
                        label: 'Jam Hadir',
                        field: 'jam_hadir',
                        sortable: true
                    },
                    {
                        name: 'status',
                        align: 'left',
                        label: 'Status',
                        field: 'status',
                        sortable: true
                    },
                ],
                data: [
                    {
                      tanggal: '18-01-2020',
                      nama_dosen: 'Rumondang',
                      matakuliah: 'English IV', 
                      kelas: '42 TRPL', 
                      ruangan: '914', 
                      jam_hadir: '08.02', 
                      status: 'Hadir'
                    },
                    {
                      tanggal: '18-01-2020',
                      nama_dosen: 'Roy Deddy',
                      matakuliah: 'PBO', 
                      kelas: '42 TRPL', 
                      ruangan: '526', 
                      jam_hadir: '10.00', 
                      status: 'Hadir'
                    },
                    {
                      tanggal: '18-01-2020',
                      nama_dosen: 'Roy Deddy',
                      matakuliah: 'PAM', 
                      kelas: '42 TRPL', 
                      ruangan: '714', 
                      jam_hadir: '13.03', 
                      status: 'Hadir'
                    },
                    {
                      tanggal: '18-01-2020',
                      nama_dosen: 'Junita',
                      matakuliah: 'PROBSTAT', 
                      kelas: '42 TRPL', 
                      ruangan: '937', 
                      jam_hadir: '15.00', 
                      status: 'Hadir'
                    },
                ],

            }
        },
        methods: {
            exportTable() {
                // naive encoding to csv format
                const content = [this.columns.map(col => wrapCsvValue(col.label))].concat(
                    this.data.map(row => this.columns.map(col => wrapCsvValue(
                        typeof col.field === 'function'
                            ? col.field(row)
                            : row[col.field === void 0 ? col.name : col.field],
                        col.format
                    )).join(','))
                ).join('\r\n')

                const status = exportFile(
                    'Laporan-Kehadiran-Dosen.csv',
                    content,
                    'text/csv'
                )

                if (status !== true) {
                    this.$q.notify({
                        message: 'Browser denied file download...',
                        color: 'negative',
                        icon: 'warning'
                    })
                }
            }
        }
}
</script>